#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <netinet/in.h>
#include "Message.h"
#include "error.h"
#include "mes_func.h"
#include "wrap.h"
#include "protcli.h"
char *
prepare_request(mesg_data_p pointer,int *size){
    char *buf;
    cl_msg_hdr_p msg_to_send;
    cl_vb_hdr_p  vb_to_send;
    vb_data_p vb;
    char *copy_place;
    int vb_to_send_len;
    int i;
    int tmp;

    buf=(char *)Malloc(MAX_MSG);
    msg_to_send=(cl_msg_hdr_p)buf;
    msg_to_send->len=sizeof(cl_msg_hdr);
    msg_to_send->ip=pointer->ip;
    msg_to_send->pdu_pr=pointer->pdu_pr;
    msg_to_send->vb_n=0;
    msg_to_send->error=0;
    copy_place=(char *)(msg_to_send+1);
    vb=pointer->data;
    for (i=0;i<pointer->vb_n;i++) {
	vb_to_send_len=sizeof(cl_vb_hdr)+vb->oid.size+vb->value.size;
	if (msg_to_send->len+vb_to_send_len<MAX_MSG){
	    msg_to_send->vb_n++;
	    vb_to_send=(cl_vb_hdr_p)copy_place;
	    vb_to_send->len=vb_to_send_len;
	    setVBV_POSITION(vb_to_send->flags,vb->vbv_present);
	    setOS_POSITION(vb_to_send->flags,vb->os_present);
	    setST_POSITION(vb_to_send->flags,vb->st_present);
	    vb_to_send->oid_len=vb->oid.size;
	    copy_place=(char *)(vb_to_send+1);
	    bcopy(vb->oid.buf,copy_place,vb->oid.size);
	    copy_place+=vb->oid.size;
	    vbv_cpv(copy_place,vb);
	    copy_place+=vb->value.size;
	    msg_to_send->len+=vb_to_send_len;
	}
	else {
	    err_msg("Unable to fit cause of MAX_MSG_SIZE");
	    return NULL;
	}
	vb++;
    }
    *size=msg_to_send->len;
    buf=(char *)Reallocf(buf,msg_to_send->len);
    return buf;
}

char *
prepare_request_failure(int *size){
    char *buf;
    cl_msg_hdr_p msg_to_send;

    buf=(char *)Malloc(MAX_MSG);
    msg_to_send=(cl_msg_hdr_p)buf;
    msg_to_send->len=sizeof(cl_msg_hdr);
    msg_to_send->vb_n=0;
    msg_to_send->error=1;
    *size=msg_to_send->len;
    buf=(char *)Reallocf(buf,msg_to_send->len);
    return buf;
}  

mesg_data_p
proceed_request(char * buff,int size,mgvp mgvp){
    mesg_data_p newmsg;
    int i;
    vb_data_p vb_pointer;
    char * next;
    char * end;
    cl_vb_hdr_p	next_pointer;
    cl_msg_hdr_p	buf;
    
    buf=(cl_msg_hdr *)buff;
    if (buf->error) {
	err_msg("Server was unable to do the request");
	return NULL;
    }
    newmsg=(mesg_data *)Calloc(1,sizeof(mesg_data));
    newmsg->version=mgvp->version;
    newmsg->ip=buf->ip;
    newmsg->community.buf=(uint8_t *)Malloc(mgvp->community.size*sizeof(uint8_t));
    if ((strncpy(newmsg->community.buf,mgvp->community.buf,mgvp->community.size))==NULL)
	err_quit("Unable to copy default community into message");
    newmsg->community.size=mgvp->community.size;
    newmsg->pdu_pr=buf->pdu_pr;
    newmsg->vb_n=0;
    vb_pointer=(vb_data_p)Calloc(buf->vb_n,sizeof(vb_data_s));
    newmsg->data=vb_pointer;
    end=(char *)(buff+size);
    next=(char *)(buf+1);
    if (next>end) {
	/* illegal message */
	err_msg("received illegal message from client");
	free(newmsg->community.buf);
	free(vb_pointer);
	free(newmsg);
	return(NULL);
    }
    for (i=0;i<buf->vb_n;i++){
	if (next+sizeof(cl_vb_hdr)>end){
	    err_msg("received illegal message from client mismatch size of vb_header %i",i+1); 
	    free_mesg_data(newmsg);
	    return(NULL);
	}
        next_pointer=(cl_vb_hdr_p)next;
	vb_pointer->vbv_present= getVBV_POSITION(next_pointer->flags);
	vb_pointer->os_present= getOS_POSITION(next_pointer->flags);
	vb_pointer->st_present= getST_POSITION(next_pointer->flags);
	vb_pointer->oid.buf=(uint8_t *)Malloc(next_pointer->oid_len*sizeof(char));
	next=(char *)(next_pointer+1);
	bcopy(next,vb_pointer->oid.buf,next_pointer->oid_len);
	vb_pointer->oid.size=next_pointer->oid_len;
	next+=next_pointer->oid_len;
	vb_pointer->value.size=next_pointer->len-next_pointer->oid_len-sizeof(cl_vb_hdr);
	if (vb_pointer->value.size>0) {
	    vb_pointer->value.buf=(uint8_t *)Malloc(vb_pointer->value.size*sizeof(uint8_t));
	    bcopy(next,vb_pointer->value.buf,vb_pointer->value.size);
	    next+=vb_pointer->value.size;
	}
	else if (vb_pointer->value.size<0){
	    err_msg("received illegal message from client mismatch of size in vb_data");
	    return(NULL);
	}
	vb_pointer++;
	newmsg->vb_n++;
    }
    return newmsg;
}